import random
import ooeuler_getter

class SimpleAI(ooeuler_getter.Player):
    def __init__(self,opt):
        self.numofsample=opt

    def start_game(self,board,player_id):
        self.player_id=player_id
        self.default_board=board
        return True

    def end_game(self,board,winner):
        pass

    def play(self,board,timeout):
        temp_board=board.get_copied_board()
        empty_cell=[ c for c in board.get_empty_cells() ]
        n=len(empty_cell)//2

        num_of_win={}
        num_of_lose={}
        for c in empty_cell:
            num_of_win[c]=0.0
            num_of_lose[c]=0.1

        a = self.player_id
        b = (a+1)%2

        for i in range(self.numofsample):
            newcells_b=random.sample(empty_cell,n)
            cells_b=board.get_cells_of(b)+newcells_b
            temp_board.set_cells(b,cells_b)
            
            newcells_a=[c for c in empty_cell if not c in newcells_b]
            cells_a=board.get_cells_of(a)+newcells_a
            temp_board.set_cells(a,cells_a)

            while temp_board.n_empty_cells()>0:
                temp_empty_cell=[ c for c in temp_board.get_empty_cells() ]
                new_cells_II=random.sample(temp_empty_cell,len(temp_empty_cell)//2)
                new_cells_I=[c for c in temp_empty_cell if not c in new_cells_II]
                temp_cells_a=temp_board.get_cells_of(a)
                temp_cells_b=temp_board.get_cells_of(b)
                if len(temp_cells_a)+len(temp_cells_b) % 2 == a:
                    temp_board.set_cells(a,temp_cells_a+new_cells_I)
                    temp_board.set_cells(b,temp_cells_b+new_cells_II)
                else:
                    temp_board.set_cells(a,temp_cells_a+new_cells_II)
                    temp_board.set_cells(b,temp_cells_b+new_cells_I)


            if temp_board.get_winner() == a :
                win=True
            else:
                win=False

            for c in newcells_a:
                if win:
                    num_of_win[c] += 1
                else:
                    num_of_lose[c] += 1

        max_data=max([num_of_win[c]/(num_of_win[c]+num_of_lose[c]) for c in empty_cell])
        for c in empty_cell:
            if  num_of_win[c]/(num_of_win[c]+num_of_lose[c])>=max_data:
                return c
        return empty_cell[0]

    def played(self,board,cell):
        pass




