import ooeuler_getter

class Board(ooeuler_getter.Board):
    def __init__(self,polyhedron,put_another_color,is_reverse_rule,cells_eachplayer=None,n_turn=None):
        ooeuler_getter.Board.__init__(self,polyhedron,cells_eachplayer,n_turn)
        self.put_another_color=put_another_color
        self.is_reverse_rule=is_reverse_rule
    def get_copied_board(self):
        return Board(self.get_polyhedron(),self.put_another_color,self.is_reverse_rule,self.cells,self.n_turn)

    def get_point(self,player):
        p=self.get_polyhedron()
        base=p.get_euler_characteristic_of(self.get_cells_of(player))
        if self.put_another_color:
            vplayer=player
        else:
            vplayer=(player+1)%2
        vert=len(self.get_vertex_cells_of(vplayer))

        if self.is_reverse_rule:
            return -(base+vert)
        else:
            return base+vert

    def get_color_of(self,cell):
        o=self.get_owner_of(cell)
        if o < 0:
            return o    
        if self.put_another_color:
            return (o+1)%2
        else:
            return o

    def get_all_cells(self):
        r=set([])
        p=self.get_polyhedron()
        r.update(p.get_faces())
        for v in p.get_vertices():
            faces=p.get_faces_containing_a_vertex(v)
            all_faces_are_owned=True
            for f in faces:
                if self.get_owner_of(f)<0:
                    all_faces_are_owned=False
                    break
            if all_faces_are_owned:
                n=0
                for e in p.get_edges_containing_a_vertex(v):
                    face_owners=[self.get_owner_of(fi) for fi in p.get_faces_containing_an_edge(e)]
                    face_owners.sort()
                    if face_owners[0] != face_owners[-1]:
                        n=n+1
                        if n>2:
                            r.add(v)
                            break

        return r
